searchNodes=[{"ref":"EctoPlaylist.html","title":"EctoPlaylist","type":"module","doc":"Implements conveniences to handle the items order of a list."},{"ref":"EctoPlaylist.html#complete_order/2","title":"EctoPlaylist.complete_order/2","type":"function","doc":"Returns the list of ids composed of the current list order + all the missings ids ordered by insertion date. Examples all_items = [%{id: 1, title: &quot;Item 1&quot;, inserted_at: ~N[2019-07-16 16:03:15]}, %{id: 2, title: &quot;Item 2&quot;, inserted_at: ~N[2019-07-16 16:04:15]}, %{id: 3, title: &quot;Item 3&quot;, inserted_at: ~N[2019-07-16 16:05:15]}, %{id: 4, title: &quot;Item 4&quot;, inserted_at: ~N[2019-07-16 16:06:15]}, %{id: 5, title: &quot;Item 5&quot;, inserted_at: ~N[2019-07-16 16:07:15]}] order = [5, 3, 1] complete_order(all_items, order) # [5, 3, 1, 2, 4]"},{"ref":"EctoPlaylist.html#missing_ids_list/1","title":"EctoPlaylist.missing_ids_list/1","type":"function","doc":"Same as missing_ids_list/2 but returns all ids ordered by insertion date."},{"ref":"EctoPlaylist.html#missing_ids_list/2","title":"EctoPlaylist.missing_ids_list/2","type":"function","doc":"Returns the list of missing ids ordered by insertion date. Examples all_items = [%{id: 1, title: &quot;Item 1&quot;, inserted_at: ~N[2019-07-16 16:03:15]}, %{id: 2, title: &quot;Item 2&quot;, inserted_at: ~N[2019-07-16 16:04:15]}, %{id: 3, title: &quot;Item 3&quot;, inserted_at: ~N[2019-07-16 16:05:15]}, %{id: 4, title: &quot;Item 4&quot;, inserted_at: ~N[2019-07-16 16:06:15]}, %{id: 5, title: &quot;Item 5&quot;, inserted_at: ~N[2019-07-16 16:07:15]}] order = [5, 3, 1] missing_ids_list(all_items, order) # [2, 4]"},{"ref":"EctoPlaylist.html#ordered_items_list/2","title":"EctoPlaylist.ordered_items_list/2","type":"function","doc":"Returns the list of items ordered according to the order list. If ids are missing in order, the items will be ordered according to their inserted date. Examples all_items = [%{id: 1, title: &quot;Item 1&quot;, inserted_at: ~N[2019-07-16 16:03:15]}, %{id: 2, title: &quot;Item 2&quot;, inserted_at: ~N[2019-07-16 16:04:15]}, %{id: 3, title: &quot;Item 3&quot;, inserted_at: ~N[2019-07-16 16:05:15]}, %{id: 4, title: &quot;Item 4&quot;, inserted_at: ~N[2019-07-16 16:06:15]}, %{id: 5, title: &quot;Item 5&quot;, inserted_at: ~N[2019-07-16 16:07:15]}] order = [5, 3, 1] ordered_items_list(all_items, order) # [%{id: 5, title: &quot;Item 5&quot;, inserted_at: ~N[2019-07-16 16:07:15]}, # %{id: 3, title: &quot;Item 3&quot;, inserted_at: ~N[2019-07-16 16:05:15]}, # %{id: 1, title: &quot;Item 1&quot;, inserted_at: ~N[2019-07-16 16:03:15]}, # %{id: 2, title: &quot;Item 2&quot;, inserted_at: ~N[2019-07-16 16:04:15]}, # %{id: 4, title: &quot;Item 4&quot;, inserted_at: ~N[2019-07-16 16:06:15]}]"},{"ref":"EctoPlaylist.Context.html","title":"EctoPlaylist.Context","type":"module","doc":"Implements conveniences to manipulate the items order list. You can implement all the functions available in this module by using this module inside of the context of the List module. (Check the guides to see how) There are two functions in this module: sync_order_list/1 and reset_order_list/1 They both take a List struct that you define when calling &quot;use&quot;. sync_order_list/1 : will add missing ids to the items order list of the list. reset_order_list/1 : will set the items order as the list of ids ordered by inserted date."},{"ref":"EctoPlaylist.ListItem.html","title":"EctoPlaylist.ListItem","type":"module","doc":"Implements conveniences to change the items order of a list."},{"ref":"EctoPlaylist.ListItem.html#first?/2","title":"EctoPlaylist.ListItem.first?/2","type":"function","doc":"Check if list item id is the first element in the ordering. iex&gt; EctoPlaylist.ListItem.first?([1, 2, 3, 4], 1) true iex&gt; EctoPlaylist.ListItem.first?([1, 2, 3, 4], 3) false iex&gt; EctoPlaylist.ListItem.first?([1, 2, 3, 4], 5) false"},{"ref":"EctoPlaylist.ListItem.html#higher_item/2","title":"EctoPlaylist.ListItem.higher_item/2","type":"function","doc":"Return the list item id which is one rank higher in the ordering. iex&gt; EctoPlaylist.ListItem.higher_item([1, 7, 3, 4], 3) 7 iex&gt; EctoPlaylist.ListItem.higher_item([1, 2, 3, 4], 1) nil iex&gt; EctoPlaylist.ListItem.higher_item([1, 2, 3, 4], 5) nil"},{"ref":"EctoPlaylist.ListItem.html#higher_items/2","title":"EctoPlaylist.ListItem.higher_items/2","type":"function","doc":"Return the list of ids above the list item id. iex&gt; EctoPlaylist.ListItem.higher_items([1, 2, 3, 4], 3) [1, 2] iex&gt; EctoPlaylist.ListItem.higher_items([1, 2, 3, 4], 4) [1, 2, 3] iex&gt; EctoPlaylist.ListItem.higher_items([1, 2, 3, 4], 1) [] iex&gt; EctoPlaylist.ListItem.higher_items([1, 2, 3, 4], 5) nil"},{"ref":"EctoPlaylist.ListItem.html#in_list?/2","title":"EctoPlaylist.ListItem.in_list?/2","type":"function","doc":"Check if list item id is in the ordering. iex&gt; EctoPlaylist.ListItem.in_list?([1, 2, 3, 4], 3) true iex&gt; EctoPlaylist.ListItem.in_list?([1, 2, 3, 4], 5) false"},{"ref":"EctoPlaylist.ListItem.html#insert_at/3","title":"EctoPlaylist.ListItem.insert_at/3","type":"function","doc":"Insert an list item id in the given index of an order_list iex&gt; EctoPlaylist.ListItem.insert_at([1, 2, 3, 4], 9, 2) [1, 9, 2, 3, 4] iex&gt; EctoPlaylist.ListItem.insert_at([1, 2, 3], 9, 10) [1, 2, 3, 9] iex&gt; EctoPlaylist.ListItem.insert_at([1, 2, 9, 3], 9, 2) [1, 9, 2, 3] iex&gt; EctoPlaylist.ListItem.insert_at([1, 2, 9, 3], 9, 10) [1, 2, 3, 9] iex&gt; EctoPlaylist.ListItem.insert_at([1, 2, 9, 3], 9, nil) [1, 2, 9, 3]"},{"ref":"EctoPlaylist.ListItem.html#last?/2","title":"EctoPlaylist.ListItem.last?/2","type":"function","doc":"Check if list item id is the last element in the ordering. iex&gt; EctoPlaylist.ListItem.last?([1, 2, 3, 4], 4) true iex&gt; EctoPlaylist.ListItem.last?([1, 2, 3, 4], 2) false iex&gt; EctoPlaylist.ListItem.last?([1, 2, 3, 4], 5) false"},{"ref":"EctoPlaylist.ListItem.html#lower_item/2","title":"EctoPlaylist.ListItem.lower_item/2","type":"function","doc":"Return the list item id which is one rank lower in the ordering. iex&gt; EctoPlaylist.ListItem.lower_item([1, 2, 3, 7], 3) 7 iex&gt; EctoPlaylist.ListItem.lower_item([1, 2, 3, 4], 4) nil iex&gt; EctoPlaylist.ListItem.lower_item([1, 2, 3, 4], 5) nil"},{"ref":"EctoPlaylist.ListItem.html#lower_items/2","title":"EctoPlaylist.ListItem.lower_items/2","type":"function","doc":"Return the list of ids below the list item id. iex&gt; EctoPlaylist.ListItem.lower_items([1, 2, 3, 4], 2) [3, 4] iex&gt; EctoPlaylist.ListItem.lower_items([1, 2, 3, 4], 1) [2, 3, 4] iex&gt; EctoPlaylist.ListItem.lower_items([1, 2, 3, 4], 4) [] iex&gt; EctoPlaylist.ListItem.lower_items([1, 2, 3, 4], 5) nil"},{"ref":"EctoPlaylist.ListItem.html#move_higher/2","title":"EctoPlaylist.ListItem.move_higher/2","type":"function","doc":"Move the list item id one rank higher in the ordering. iex&gt; EctoPlaylist.ListItem.move_higher([1, 2, 3, 4], 3) [1, 3, 2, 4] iex&gt; EctoPlaylist.ListItem.move_higher([1, 2, 3, 4], 1) [1, 2, 3, 4] iex&gt; EctoPlaylist.ListItem.move_higher([1, 2, 3, 4], 5) [1, 2, 3, 4]"},{"ref":"EctoPlaylist.ListItem.html#move_lower/2","title":"EctoPlaylist.ListItem.move_lower/2","type":"function","doc":"Move the list item id one rank lower in the ordering. iex&gt; EctoPlaylist.ListItem.move_lower([1, 2, 3, 4], 3) [1, 2, 4, 3] iex&gt; EctoPlaylist.ListItem.move_lower([1, 2, 3, 4], 1) [2, 1, 3, 4] iex&gt; EctoPlaylist.ListItem.move_lower([1, 2, 3, 4], 4) [1, 2, 3, 4] iex&gt; EctoPlaylist.ListItem.move_lower([1, 2, 3, 4], 5) [1, 2, 3, 4]"},{"ref":"EctoPlaylist.ListItem.html#move_to_bottom/2","title":"EctoPlaylist.ListItem.move_to_bottom/2","type":"function","doc":"Move the list item id at the last position in the ordering. iex&gt; EctoPlaylist.ListItem.move_to_bottom([1, 2, 3, 4], 3) [1, 2, 4, 3] iex&gt; EctoPlaylist.ListItem.move_to_bottom([1, 2, 3, 4], 1) [2, 3, 4, 1] iex&gt; EctoPlaylist.ListItem.move_to_bottom([1, 2, 3, 4], 4) [1, 2, 3, 4] iex&gt; EctoPlaylist.ListItem.move_to_bottom([1, 2, 3, 4], 5) [1, 2, 3, 4, 5]"},{"ref":"EctoPlaylist.ListItem.html#move_to_top/2","title":"EctoPlaylist.ListItem.move_to_top/2","type":"function","doc":"Move the list item id at the first position in the ordering. iex&gt; EctoPlaylist.ListItem.move_to_top([1, 2, 3, 4], 3) [3, 1, 2, 4] iex&gt; EctoPlaylist.ListItem.move_to_top([1, 2, 3, 4], 1) [1, 2, 3, 4] iex&gt; EctoPlaylist.ListItem.move_to_top([1, 2, 3, 4], 5) [5, 1, 2, 3, 4]"},{"ref":"EctoPlaylist.ListItem.html#not_in_list?/2","title":"EctoPlaylist.ListItem.not_in_list?/2","type":"function","doc":"Check if list item id is in the ordering. iex&gt; EctoPlaylist.ListItem.not_in_list?([1, 2, 3, 4], 5) true iex&gt; EctoPlaylist.ListItem.not_in_list?([1, 2, 3, 4], 3) false"},{"ref":"EctoPlaylist.ListItem.html#remove_from_list/2","title":"EctoPlaylist.ListItem.remove_from_list/2","type":"function","doc":"Remove the list item id in the ordering. iex&gt; EctoPlaylist.ListItem.remove_from_list([1, 2, 3, 4], 3) [1, 2, 4] iex&gt; EctoPlaylist.ListItem.remove_from_list([1, 2, 3, 4], 1) [2, 3, 4] iex&gt; EctoPlaylist.ListItem.remove_from_list([1, 2, 3, 4], 5) [1, 2, 3, 4]"},{"ref":"readme.html","title":"ecto_playlist","type":"extras","doc":"ecto_playlist Ecto_playlist is a simple library that helps you manage ordered model with Ecto."},{"ref":"readme.html#description","title":"ecto_playlist - Description","type":"extras","doc":"Let&#39;s take an example of an ordered model: a Playlist which contains an ordered list of Schemes. Instead of storing the position of each scheme in the schemes themselves, we will store the ordering in the playlist and we will call EctoPlaylist.ordered_items_list/2 to return for us the list of items properly ordered."},{"ref":"readme.html#installation","title":"ecto_playlist - Installation","type":"extras","doc":"Read the tutorial to understand the process of installation of the library."},{"ref":"readme.html#functions-available","title":"ecto_playlist - Functions available","type":"extras","doc":"In EctoPlaylist.ListItem, you have a set of functions to modify the ordering of your order list. Functions That Change Position and Reorder List EctoPlaylist.ListItem.insert_at/3 EctoPlaylist.ListItem.move_lower/2 will do nothing if the item is the lowest item EctoPlaylist.ListItem.move_higher/2 will do nothing if the item is the highest item EctoPlaylist.ListItem.move_to_bottom/2 EctoPlaylist.ListItem.move_to_top/2 EctoPlaylist.ListItem.remove_from_list/2 Methods That Return Data of the Item&#39;s List Position EctoPlaylist.ListItem.first?/2 EctoPlaylist.ListItem.last?/2 EctoPlaylist.ListItem.in_list?/2 EctoPlaylist.ListItem.not_in_list?/2 EctoPlaylist.ListItem.higher_item/2 EctoPlaylist.ListItem.higher_items/2 will return all the ids above the given list item id in the order_list EctoPlaylist.ListItem.lower_item/2 EctoPlaylist.ListItem.lower_items/2 will return all the ids below the given list item id in the order_list"},{"ref":"readme.html#documentation","title":"ecto_playlist - Documentation","type":"extras","doc":"The documentation can be found here: https://hexdocs.pm/ecto_playlist."}]